diff --git a/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php b/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php
index 7c56abc..b1512d1 100644
--- a/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php
+++ b/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php
@@ -325,10 +325,16 @@ class LocalDriver extends \TYPO3\CMS\Core\Resource\Driver\AbstractDriver {
 			if ($this->applyFilterMethodsToDirectoryItem($filterMethods, $iteratorItem, $identifier, $path, isset($itemRows[$identifier]) ? array('indexData' => $itemRows[$identifier]) : array()) === FALSE) {
 				continue;
 			}
+			$pathWithIteratorItemPath = $path;
+			$iteratorItemPath = dirname($iteratorItem);
+			if ($iteratorItemPath != '.') {
+				$iteratorItem = basename($iteratorItem);
+				$pathWithIteratorItemPath = $path . $iteratorItemPath . '/';
+			}
 			if (isset($itemRows[$identifier])) {
-				list($key, $item) = $this->{$itemHandlerMethod}($iteratorItem, $path, $itemRows[$identifier]);
+				list($key, $item) = $this->{$itemHandlerMethod}($iteratorItem, $pathWithIteratorItemPath, $itemRows[$identifier]);
 			} else {
-				list($key, $item) = $this->{$itemHandlerMethod}($iteratorItem, $path);
+				list($key, $item) = $this->{$itemHandlerMethod}($iteratorItem, $pathWithIteratorItemPath);
 			}
 			if (empty($item)) {
 				continue;
